#!/bin/sh

basedir="/usr/local"

if [ "$1" = "-update" -o "$1" = "--update" ]; then
	echo '13' >$HOME/alisp/.version
	if [ ! -d $HOME/alisp/ext ]; then
		mkdir $HOME/alisp/ext
	fi
	cp $basedir/share/alisp/lib/*.l $HOME/alisp/lib
	cp $basedir/share/alisp/ext/*.l $HOME/alisp/ext
	echo
	echo "Your ArrowLISP library files in $HOME/alisp/lib"
	echo "and $HOME/alisp/ext have been udated."
	echo
	echo -n \
	"Replace the example files in your $HOME/alisp/src directory? (y/n) "
	read x
	echo
	case $x in
		y|yes|Y|Yes|YES)
			cp $basedir/share/alisp/src/*.[lm] $HOME/alisp/src
			echo "Your $HOME/alisp/src directory has been updated"
			echo
			;;
	esac
	exit 0
fi

if [ -d $HOME/alisp ]; then
	echo
	echo "Your ArrowLISP environment is already set up."
	echo "Its base directory is $HOME/alisp."
	echo
	echo "You may run alisp_install with the --update"
	echo "option to update the library files."
	echo
	exit 1
fi

mkdir $HOME/alisp
mkdir $HOME/alisp/ext
mkdir $HOME/alisp/lib
mkdir $HOME/alisp/src

cp $basedir/share/alisp/lib/*.l $HOME/alisp/lib
cp $basedir/share/alisp/ext/*.l $HOME/alisp/ext
cp $basedir/share/alisp/src/*.[lm] $HOME/alisp/src

echo '13' >$HOME/alisp/.version

echo
echo "Your ArrowLISP base directory is $HOME/alisp"
echo

