BEGIN	{
	lineno = 0
	Nmodels = 0
	PrevFN = ENVIRON["PF"]
	PrevFN = substr(PrevFN, index(PrevFN, "/")+1)
	PrevFN = substr(PrevFN, 1, index(PrevFN, ".")-1)
	FNname = ENVIRON["TF"]
	FNname = substr(FNname, index(FNname, "/")+1)
	FNname = substr(FNname, 1, index(FNname, ".")-1)
	SrcDir = ENVIRON["TF"]
	SrcDir = substr(SrcDir, 1, index(SrcDir, "/")-1)
	NextFN = ENVIRON["NF"]
	NextFN = substr(NextFN, index(NextFN, "/")+1)
	NextFN = substr(NextFN, 1, index(NextFN, ".")-1)
	Root   = ENVIRON["RO"]
	}
function endsection() {
	if (lineno == 0) {
		/* skip */
	}
	else if (substr(lines[0], 1, 2) == ":c" || \
		substr(lines[0], 1, 2) == ";c" || \
		substr(lines[0], 1, 2) == ":l" || \
		substr(lines[0], 1, 2) == ";l" \
	) {
		last=""
		for (x=0; x<lineno; x++) {
			libs[x,"name"] = substr(lines[x],
				index(lines[x], "/")+1)
			libs[x,"name"] = substr(libs[x,"name"], 1,
				index(libs[x,"name"], ".")-1)
			if (last != "" && substr(lines[x], 1, 1) == ";") {
				libs[x,"file"] = last
			}
			else {
				libs[x,"file"] = tolower(libs[x,"name"])
				last = libs[x,"file"]
			}
		}
		Nlibs = x
	}
	else if (lines[0] == "---purpose---") {
		y = 0
		for (x=1; x<lineno; x++)
			if (lines[x] != ";") purpose[y++] = lines[x]
		Npurpose = y
	}
	else if (lines[0] == "---args---") {
		Nargs = 0
		for(x=1; x<lineno; x++) {
			desc = index(lines[x], " - ")
			if (desc != 0) {
				args[Nargs,"name"] = substr(lines[x], 1, desc-1)
				args[Nargs,"desc"] = substr(lines[x], desc+3)
				Nargs++
			}
			else {
				while (substr(lines[x], 1, 1) == " ")
					lines[x] = substr(lines[x], 2)
				args[Nargs-1,"desc"] = \
					args[Nargs-1,"desc"] "\n" lines[x]
			}
		}
	}
	else if (lines[0] == "---keywords---") {
		for (x=1; x<lineno; x++) keywords[x-1] = lines[x]
		Nkwords = x-1
	}
	else if (lines[0] == "---see-also---") {
		for (x=1; x<lineno; x++) refs[x-1] = lines[x]
		Nrefs = x-1
	}
	else if (lines[0] == "---model---") {
		for (x=1; x<lineno; x++)
			if (lines[x] != ";")
				model[Nmodels,x-1] = lines[x]
			else
				model[Nmodels,x-1] = ""
		model[Nmodels,len] = x-1
		Nmodels++
	}
	else if (lines[0] == "---example---") {
		for (x=1; x<lineno; x++)
			if (lines[x] != ";")
				example[x-1] = lines[x]
			else
				example[x-1] = ""
		Nexam = x-1
	}
	else if (lines[0] == "---code---") {
		for (x=1; x<lineno; x++) code[x-1] = lines[x]
		Ncode = x-1
	}
	lineno = 0
	}
/^$/	{
	if (lines[0] != "---code---") {
		endsection()
		next
	}
	}
	{
	lines[lineno++] = $0
	}
function writemenu() {
	print  "<TABLE cellspacing=0 cellpadding=0 border=0 width=\"100%\">"
	print  " <TR>"
	print  "  <TD align=\"left\" width=\"40%\">"
	printf "   Previous: <A href=\"%s.html\">%s</A>", PrevFN, PrevFN
	print  "  </TD>"
	print  "  <TD align=\"center\" width=\"20%\">"
	printf "   <A href=\"%s.html\">%s</A>", Root, Root
	print  "  </TD>"
	print  "  <TD align=\"right\" width=\"40%\">"
	printf "   Next: <A href=\"%s.html\">%s</A>", NextFN, NextFN
	print  "  </TD>"
	print  " </TR>"
	print  "</TABLE>"
	}
function writeprolog() {
	print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0" \
		" Transitional//EN\">"
	print "<HTML>"
	print "<HEAD>"
	printf "<TITLE>Nils LISP Pages: Code Library: %s</TITLE>\n", FNname
	printf "<META name=\"description\" content=\"LISP library: %s\">\n", \
		FNname
	print "<META name=\"keywords\"" \
		"content=\"LISP sources, LISP functions, LISP code\">"
	for (x=0; x<Nkwords; x++) {
		printf "<META name=\"keywords\" content=\"%s\">\n", \
			keywords[x]
	}
	print "@HEAD"
	print ""
	writemenu()
	print ""
	printf "<H2>%s</H2>\n", toupper(FNname)
	print ""
	}
function writedesc() {
	print "<TABLE width=\"100%\" border=0>"
	print " <TR>"
	print "  <TD width=\"50%\" valign=\"top\">"
	print "   <B>Purpose:</B><BR>"
	for (x=0; x<Npurpose; x++) {
		if (purpose[x] == "-") {
			printf "   <BR>\n"
		}
		else if (purpose[x] == "--") {
			printf "   <BR>&nbsp;<BR>\n"
		}
		else {
			gsub("&", "\\&amp;", purpose[x])
			gsub("<", "\\&lt;", purpose[x])
			gsub(">", "\\&gt;", purpose[x])
			printf "   %s\n", purpose[x]
		}
	}
	print "  </TD><TD><TT>&nbsp;</TT></TD>"
	print "  <TD width=\"45%\" valign=\"top\">"
	if (Nargs > 0) {
		print "   <B>Arguments:</B><BR>"
		for (x=0; x<Nargs; x++) {
			gsub("&", "\\&amp;", args[x,"desc"])
			gsub("<", "\\&lt;", args[x,"desc"])
			gsub(">", "\\&gt;", args[x,"desc"])
			printf "   <B>%s</B> - %s", \
				args[x,"name"], args[x,"desc"]
			print (x<Nargs-1)? "<BR>": ""
		}
	}
	else {
		print "   &nbsp;"
	}
	print "  </TD>"
	print " </TR>"
	print "</TABLE>"
	}
function printcode(line) {
	gsub("&", "\\&amp;", line)
	gsub("<", "\\&lt;", line)
	gsub(">", "\\&gt;", line)
	semi = index(line, ";")
	for (j=0; j<Nlibs; j++) {
		pos = 1
		while (1) {
			k = index(substr(line, pos), libs[j,"name"])
			pos += k
			if (k <= 0) break
			k = pos-1
			l = length(libs[j,"name"])
			if (k > 0) {
				c = substr(line, k+l, 1)
				if (index( \
					"abcdefghijklmnopqrstuvwxyz-",\
					c) != 0)
						k = 0;
				if (k > 1) {
					c = substr(line, k-1, 1)
					if (index( \
					"abcdefghijklmnopqrstuvwxyz-",\
						c) != 0)
							k = 0;
				}
			}
			if (k > 0) break
		}
		if (semi > 0 && k >= semi) k = 0
		if (l != 0 && k > 0) {
			s1 = substr(line, 1, k-1)
			href = sprintf("<A href=\"%s.html\">%s</A>", \
				libs[j,"file"], libs[j,"name"])
			s2 = substr(line, k+l)
			line = s1 href s2
			libs[j,"name"] = "?" libs[j,"name"]
		}
	}
	k = index(line, ";")
	if (k > 0) {
		s1 = substr(line, 1, k)
		s2 = substr(line, k+1)
		line = s1 "<I>" s2 "</I>"
	}
	print line
	}
function writecode(prog, len, title) {
	printf "<P><B>%s:</B></P>\n", title
	print "<PRE>"
	for (x=0; x<len; x++) {
		printcode(prog[x])
	}
	print "</PRE>"
	for (j=0; j<Nlibs; j++) {
		if (substr(libs[j,"name"], 1, 1) == "?")
			libs[j,"name"] = substr(libs[j,"name"], 2)
	}
	}
function writeexam(prog, len) {
	print "<P><B>Example:</B></P>"
	print "<PRE>"
	printf ":l %s/%s.l\n", tolower(SrcDir), tolower(FNname)
	for (x=0; x<len; x++) {
		print(prog[x])
	}
	print "</PRE>"
	for (j=0; j<Nlibs; j++) {
		if (substr(libs[j,"name"], 1, 1) == "?")
			libs[j,"name"] = substr(libs[j,"name"], 2)
	}
	}
function writeepilog() {
	print ""
	writemenu()
	print ""
	print "@TAIL"
	print ""
	print "</BODY>"
	print "</HTML>"
	}
function writerefs() {
	if (Nrefs) {
		print "<P><B>See also:</B><BR>"
		for (x=0; x<Nrefs; x++) {
			for (comma=1; comma != 0; ) {
				comma = index(refs[x], ",")
				if (comma != 0) {
					ref = substr(refs[x], 1, comma-1)
					refs[x] = substr(refs[x], comma+2)
				}
				else {
					ref = refs[x]
				}
				printf "<A href=\"%s.html\"><TT>%s</TT></A>", \
					tolower(ref), ref
				if (comma != 0 || x < Nrefs-1)
					printf "<TT>,</TT>\n"
			}
		}
		print "<TT>.</TT>\n</P>"
	}
	}
function writetmpl() {
		writeprolog()
		writedesc()
		for (mod=0; mod<Nmodels; mod++) {
			for (lns=0; lns<model[mod,len]; lns++)
				mcode[lns] = model[mod,lns]
			writecode(mcode, model[mod,len], "Model")
		}
		writecode(code, Ncode, "Implementation")
		if (Nexam) writeexam(example, Nexam)
		writerefs()
		writeepilog()
	}
END	{
	endsection()
	writetmpl()
	}
